diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
index fbd35c2bb..daa9e0208 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
@@ -32,7 +32,7 @@ public class WorldTypeFXNether extends WorldTypeFX{
             float r = ((color >> 16) & 0xFF) / 255.0f;
             float g = ((color >> 8) & 0xFF) / 255.0f;
             float b = (color & 0xFF) / 255.0f;
-            return Vec3.getTempVec3(r, g, b);
+            return Vec3.fromPool(r, g, b);
         }
 
         float r = 60 / 255.0f;
@@ -53,7 +53,7 @@ public class WorldTypeFXNether extends WorldTypeFX{
             b = MathHelper.lerp(0, b, (float) toLerp);
         }
 
-        return Vec3.getTempVec3(r, g, b);
+        return Vec3.fromPool(r, g, b);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXOverworld.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXOverworld.java
index 039a25abb..b4e34c648 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXOverworld.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXOverworld.java
@@ -57,6 +57,6 @@ public class WorldTypeFXOverworld extends WorldTypeFX{
         r *= dayProgress * 0.94f + 0.06f;
         g *= dayProgress * 0.94f + 0.06f;
         b *= dayProgress * 0.91f + 0.09f;
-        return Vec3.getTempVec3(r, g, b);
+        return Vec3.fromPool(r, g, b);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/sound/SoundRepository.java b/game/client/src/main/java/net/minecraft/client/sound/SoundRepository.java
index d58bf7cd1..bf3754099 100644
--- a/game/client/src/main/java/net/minecraft/client/sound/SoundRepository.java
+++ b/game/client/src/main/java/net/minecraft/client/sound/SoundRepository.java
@@ -104,7 +104,7 @@ public class SoundRepository extends Registry<NamedSoundRepository> {
             value = split[1];
             if (namespace.isEmpty()) throw new IllegalArgumentException("Invalid key '" + key + "', Namespace must not be empty!");
         }
-        return NamespaceID.getTemp(namespace, value);
+        return NamespaceID.fromPool(namespace, value);
     }
 
     public static void initialize(Minecraft mc) {
diff --git a/game/client/src/main/java/net/minecraft/client/util/linalg/MatrixStack.java b/game/client/src/main/java/net/minecraft/client/util/linalg/MatrixStack.java
new file mode 100644
index 000000000..cc7d68aa6
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/util/linalg/MatrixStack.java
@@ -0,0 +1,92 @@
+package net.minecraft.client.util.linalg;
+
+import net.minecraft.core.util.linalg.Matrix4;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.opengl.GL11;
+
+/**
+ * Provides an abstraction over OpenGL's matrix functions, to aid in porting to OpenGL 3 later on.
+ */
+public class MatrixStack {
+    /**
+     * The model-view matrix stack, corresponding to GL_MODELVIEW.
+     */
+    public static final @NotNull MatrixStack MODEL_VIEW = new MatrixStack(GL11.GL_MODELVIEW, GL11.GL_MODELVIEW_MATRIX);
+    /**
+     * The projection matrix stack, corresponding to GL_PROJECTION.
+     */
+    public static final @NotNull MatrixStack PROJECTION = new MatrixStack(GL11.GL_PROJECTION, GL11.GL_PROJECTION_MATRIX);
+    /**
+     * The texture matrix stack, corresponding to GL_TEXTURE.
+     */
+    public static final @NotNull MatrixStack TEXTURE = new MatrixStack(GL11.GL_TEXTURE, GL11.GL_TEXTURE_MATRIX);
+
+    private final int matrixMode;
+    private final int matrixMode2;
+
+    private int depth = 0;
+
+    private MatrixStack(final int matrixMode, final int matrixMode2) {
+        this.matrixMode = matrixMode;
+        this.matrixMode2 = matrixMode2;
+    }
+
+    /**
+     * Returns the top of the matrix stack.
+     */
+    public @NotNull Matrix4 peek() {
+        GL11.glMatrixMode(this.matrixMode);
+
+        final double[] buffer = new double[16];
+        GL11.glGetDoublev(this.matrixMode2, buffer);
+
+        return Matrix4.fromPool(
+            buffer[0], buffer[1], buffer[2], buffer[3],
+            buffer[4], buffer[5], buffer[6], buffer[7],
+            buffer[8], buffer[9], buffer[10], buffer[11],
+            buffer[12], buffer[13], buffer[14], buffer[15]
+        );
+    }
+
+    /**
+     * Pushes a duplicate of the current matrix onto the matrix stack.
+     */
+    public void push() {
+        GL11.glMatrixMode(this.matrixMode);
+
+        GL11.glPushMatrix();
+
+        this.depth += 1;
+    }
+
+    /**
+     * Pops the current matrix from the matrix stack. If the stack becomes empty, an identity matrix will be inserted.
+     */
+    public void pop() {
+        GL11.glMatrixMode(this.matrixMode);
+
+        if (this.depth == 0) {
+            GL11.glLoadIdentity();
+        } else {
+            GL11.glPopMatrix();
+        }
+    }
+
+    /**
+     * Replaces the current matrix with the identity matrix.
+     */
+    public void loadIdentity() {
+        GL11.glMatrixMode(this.matrixMode);
+
+        GL11.glLoadIdentity();
+    }
+
+    /**
+     * Replaces the current matrix with the given matrix.
+     */
+    public void load(final @NotNull Matrix4 matrix) {
+        GL11.glMatrixMode(this.matrixMode);
+
+        GL11.glLoadMatrixd(matrix.asArray());
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index 425038471..07dcacda2 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -79,7 +79,7 @@ public class WorldClient extends World {
         r *= f2 * 0.9F + 0.1F;
         g *= f2 * 0.9F + 0.1F;
         b *= f2 * 0.85F + 0.15F;
-        return Vec3.getTempVec3(r, g, b);
+        return Vec3.fromPool(r, g, b);
     }
 
     public Vec3 getFogColor(ICamera camera, float partialTick)
@@ -155,7 +155,7 @@ public class WorldClient extends World {
             g = g * (1.0F - f12) + 0.8F * f12;
             b = b * (1.0F - f12) + f12;
         }
-        return Vec3.getTempVec3(r, g, b);
+        return Vec3.fromPool(r, g, b);
     }
 
     @Override
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
index 4454f7bee..954aab092 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
@@ -255,7 +255,7 @@ public class BlockModelMojangData implements BlockModelData {
                 }
             }
             try {
-                return new BlockModelMojangData(texturePackList, NamespaceID.getPermanent(id), this.parent, this.ambientOcclusion, this.renderLayer, this.displayPosMap, this.textures, this.particleIndices, elementList);
+                return new BlockModelMojangData(texturePackList, NamespaceID.fromPool(id).copyUnpooled(), this.parent, this.ambientOcclusion, this.renderLayer, this.displayPosMap, this.textures, this.particleIndices, elementList);
             } catch (final HardIllegalArgumentException e) {
                 throw new IllegalArgumentException(e);
             }
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/EntityGeometryMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/EntityGeometryMojangData.java
index 83a9f9efc..1770709c5 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/EntityGeometryMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/EntityGeometryMojangData.java
@@ -291,7 +291,7 @@ public class EntityGeometryMojangData implements EntityModelData {
                         for (final Map.Entry<String, JsonElement> entry : renderersObj.entrySet()) {
                             final NamespaceID id;
                             try {
-                                id = NamespaceID.getPermanent(entry.getKey());
+                                id = NamespaceID.fromPool(entry.getKey()).copyUnpooled();
                             } catch (final HardIllegalArgumentException exception) {
                                 LOGGER.error("Id '{}' is malformed!", entry.getKey(), exception);
                                 continue;
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
index f5434543a..b19d17b24 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
@@ -39,13 +39,14 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             i++;
         }
 
-        this.visBounds = AABB.getPermanentBB(
+        this.visBounds = AABB.fromPool(
             (this.data.vBoundsOffset[0] - this.data.vBoundsWidth /2),
             (this.data.vBoundsOffset[1] - this.data.vBoundsHeight/2),
             (this.data.vBoundsOffset[2] - this.data.vBoundsWidth /2),
             (this.data.vBoundsOffset[0] + this.data.vBoundsWidth /2),
             (this.data.vBoundsOffset[1] + this.data.vBoundsHeight/2),
-            (this.data.vBoundsOffset[2] + this.data.vBoundsWidth /2));
+            (this.data.vBoundsOffset[2] + this.data.vBoundsWidth /2)
+        ).copyUnpooled();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
index 26c36de60..2783692d9 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
@@ -25,7 +25,7 @@ public class Achievement extends Stat
 
     public Achievement(NamespaceID id, String name, int iconItemId, Achievement parent)
     {
-        super(NamespaceID.getPermanent(id.namespace(), "achievement/" + id.value()), "achievement." + name);
+        super(NamespaceID.fromPool(id.namespace(), "achievement/" + id.value()), "achievement." + name);
         this.iconItemId = iconItemId;
         this.description = "achievement." + name;
 
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
index ab9f2d21a..3dc8201c5 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
@@ -11,130 +11,130 @@ public abstract class Achievements
 {
     public static List<Achievement> achievementList = new ArrayList<>();
     public static Achievement OPEN_INVENTORY =
-        new Achievement(NamespaceID.getPermanent("minecraft", "open_inventory"), "openInventory", Items.BOOK, null)
+        new Achievement(NamespaceID.fromPool("minecraft", "open_inventory"), "openInventory", Items.BOOK, null)
         .setClientsideAchievement().registerAchievement();
     public static Achievement MINE_WOOD =
-        new Achievement(NamespaceID.getPermanent("minecraft", "mine_wood"), "mineWood", Blocks.LOG_OAK, OPEN_INVENTORY)
+        new Achievement(NamespaceID.fromPool("minecraft", "mine_wood"), "mineWood", Blocks.LOG_OAK, OPEN_INVENTORY)
             .registerAchievement();
     public static Achievement BUILD_WORKBENCH =
-        new Achievement(NamespaceID.getPermanent("minecraft", "build_workbench"), "buildWorkBench", Blocks.WORKBENCH, MINE_WOOD)
+        new Achievement(NamespaceID.fromPool("minecraft", "build_workbench"), "buildWorkBench", Blocks.WORKBENCH, MINE_WOOD)
             .registerAchievement();
     public static Achievement BUILD_PICKAXE =
-        new Achievement(NamespaceID.getPermanent("minecraft", "build_pickaxe"), "buildPickaxe", Items.TOOL_PICKAXE_WOOD, BUILD_WORKBENCH)
+        new Achievement(NamespaceID.fromPool("minecraft", "build_pickaxe"), "buildPickaxe", Items.TOOL_PICKAXE_WOOD, BUILD_WORKBENCH)
             .registerAchievement();
     public static Achievement BUILD_FURNACE =
-        new Achievement(NamespaceID.getPermanent("minecraft", "build_furnace"), "buildFurnace", Blocks.FURNACE_STONE_ACTIVE, BUILD_PICKAXE)
+        new Achievement(NamespaceID.fromPool("minecraft", "build_furnace"), "buildFurnace", Blocks.FURNACE_STONE_ACTIVE, BUILD_PICKAXE)
             .registerAchievement();
     public static Achievement ACQUIRE_IRON =
-        new Achievement(NamespaceID.getPermanent("minecraft", "acquire_iron"), "acquireIron", Items.INGOT_IRON, BUILD_FURNACE)
+        new Achievement(NamespaceID.fromPool("minecraft", "acquire_iron"), "acquireIron", Items.INGOT_IRON, BUILD_FURNACE)
             .registerAchievement();
     public static Achievement GET_DIAMONDS =
-        new Achievement(NamespaceID.getPermanent("minecraft", "get_diamonds"), "getDiamonds", Items.DIAMOND, ACQUIRE_IRON)
+        new Achievement(NamespaceID.fromPool("minecraft", "get_diamonds"), "getDiamonds", Items.DIAMOND, ACQUIRE_IRON)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement BUILD_HOE =
-        new Achievement(NamespaceID.getPermanent("minecraft", "build_hoe"), "buildHoe", Items.TOOL_HOE_WOOD, BUILD_WORKBENCH)
+        new Achievement(NamespaceID.fromPool("minecraft", "build_hoe"), "buildHoe", Items.TOOL_HOE_WOOD, BUILD_WORKBENCH)
             .registerAchievement();
     public static Achievement MAKE_BREAD =
-        new Achievement(NamespaceID.getPermanent("minecraft", "make_bread"), "makeBread", Items.FOOD_BREAD, BUILD_HOE)
+        new Achievement(NamespaceID.fromPool("minecraft", "make_bread"), "makeBread", Items.FOOD_BREAD, BUILD_HOE)
             .registerAchievement();
     public static Achievement BAKE_CAKE =
-        new Achievement(NamespaceID.getPermanent("minecraft", "bake_cake"), "bakeCake", Items.FOOD_CAKE, BUILD_HOE)
+        new Achievement(NamespaceID.fromPool("minecraft", "bake_cake"), "bakeCake", Items.FOOD_CAKE, BUILD_HOE)
             .registerAchievement();
     public static Achievement CRAFT_ICECREAM =
-        new Achievement(NamespaceID.getPermanent("minecraft", "craft_icecream"), "craftIcecream", Items.BUCKET_ICECREAM, BUILD_HOE)
+        new Achievement(NamespaceID.fromPool("minecraft", "craft_icecream"), "craftIcecream", Items.BUCKET_ICECREAM, BUILD_HOE)
             .registerAchievement();
     public static Achievement CRAFT_PUMPKIN_PIE =
-        new Achievement(NamespaceID.getPermanent("minecraft", "craft_pumpkin_pie"), "craftPumpkinPie", Items.FOOD_PUMPKIN_PIE, BUILD_HOE)
+        new Achievement(NamespaceID.fromPool("minecraft", "craft_pumpkin_pie"), "craftPumpkinPie", Items.FOOD_PUMPKIN_PIE, BUILD_HOE)
             .registerAchievement();
     public static Achievement BUILD_BETTER_PICKAXE =
-        new Achievement(NamespaceID.getPermanent("minecraft", "build_better_pickaxe"), "buildBetterPickaxe", Items.TOOL_PICKAXE_STONE, BUILD_PICKAXE)
+        new Achievement(NamespaceID.fromPool("minecraft", "build_better_pickaxe"), "buildBetterPickaxe", Items.TOOL_PICKAXE_STONE, BUILD_PICKAXE)
             .registerAchievement();
     public static Achievement COOK_FISH =
-        new Achievement(NamespaceID.getPermanent("minecraft", "cook_fish"), "cookFish", Items.FOOD_FISH_COOKED, BUILD_FURNACE)
+        new Achievement(NamespaceID.fromPool("minecraft", "cook_fish"), "cookFish", Items.FOOD_FISH_COOKED, BUILD_FURNACE)
             .registerAchievement();
     public static Achievement ON_A_RAIL =
-        new Achievement(NamespaceID.getPermanent("minecraft", "on_a_rail"), "onARail", Blocks.RAIL, ACQUIRE_IRON)
+        new Achievement(NamespaceID.fromPool("minecraft", "on_a_rail"), "onARail", Blocks.RAIL, ACQUIRE_IRON)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement BUILD_SWORD =
-        new Achievement(NamespaceID.getPermanent("minecraft", "build_sword"), "buildSword", Items.TOOL_SWORD_WOOD, BUILD_WORKBENCH)
+        new Achievement(NamespaceID.fromPool("minecraft", "build_sword"), "buildSword", Items.TOOL_SWORD_WOOD, BUILD_WORKBENCH)
             .registerAchievement();
     public static Achievement ALL_ARMOR_TYPES =
-        new Achievement(NamespaceID.getPermanent("minecraft", "all_armor_types"), "allArmorTypes", Items.ARMOR_CHESTPLATE_STEEL, null)
+        new Achievement(NamespaceID.fromPool("minecraft", "all_armor_types"), "allArmorTypes", Items.ARMOR_CHESTPLATE_STEEL, null)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement KILL_ENEMY =
-        new Achievement(NamespaceID.getPermanent("minecraft", "kill_enemy"), "killEnemy", Items.BONE, BUILD_SWORD)
+        new Achievement(NamespaceID.fromPool("minecraft", "kill_enemy"), "killEnemy", Items.BONE, BUILD_SWORD)
             .registerAchievement();
     public static Achievement KILL_COW =
-        new Achievement(NamespaceID.getPermanent("minecraft", "kill_cow"), "killCow", Items.LEATHER, BUILD_SWORD)
+        new Achievement(NamespaceID.fromPool("minecraft", "kill_cow"), "killCow", Items.LEATHER, BUILD_SWORD)
             .registerAchievement();
     public static Achievement FLY_PIG =
-        new Achievement(NamespaceID.getPermanent("minecraft", "fly_pig"), "flyPig", Items.SADDLE, KILL_COW)
+        new Achievement(NamespaceID.fromPool("minecraft", "fly_pig"), "flyPig", Items.SADDLE, KILL_COW)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement GET_SENSED =
-        new Achievement(NamespaceID.getPermanent("minecraft", "get_sensed"), "getSensed", Blocks.MOTION_SENSOR_ACTIVE, KILL_ENEMY)
+        new Achievement(NamespaceID.fromPool("minecraft", "get_sensed"), "getSensed", Blocks.MOTION_SENSOR_ACTIVE, KILL_ENEMY)
             .registerAchievement();
     public static Achievement CRAFT_HANDCANNON =
-        new Achievement(NamespaceID.getPermanent("minecraft", "craft_hand_cannon"), "craftHandCannon", Items.HANDCANNON_UNLOADED, BUILD_BETTER_PICKAXE)
+        new Achievement(NamespaceID.fromPool("minecraft", "craft_hand_cannon"), "craftHandCannon", Items.HANDCANNON_UNLOADED, BUILD_BETTER_PICKAXE)
             .registerAchievement();
     public static Achievement COLLECT_STONE =
-        new Achievement(NamespaceID.getPermanent("minecraft", "collect_stone"), "collectStone", Blocks.COBBLE_LIMESTONE, BUILD_PICKAXE)
+        new Achievement(NamespaceID.fromPool("minecraft", "collect_stone"), "collectStone", Blocks.COBBLE_LIMESTONE, BUILD_PICKAXE)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement CRUSH_BLOCKS =
-        new Achievement(NamespaceID.getPermanent("minecraft", "crush_blocks"), "crushBlocks", Blocks.ICE, BUILD_BETTER_PICKAXE)
+        new Achievement(NamespaceID.fromPool("minecraft", "crush_blocks"), "crushBlocks", Blocks.ICE, BUILD_BETTER_PICKAXE)
             .registerAchievement();
     public static Achievement REPAIR_ARMOR =
-        new Achievement(NamespaceID.getPermanent("minecraft", "repair_armor"), "repairArmor", Items.CHAINLINK, KILL_ENEMY)
+        new Achievement(NamespaceID.fromPool("minecraft", "repair_armor"), "repairArmor", Items.CHAINLINK, KILL_ENEMY)
             .registerAchievement();
     public static Achievement GET_CHAINMAIL =
-        new Achievement(NamespaceID.getPermanent("minecraft", "get_chainmail"), "getChainmail", Items.ARMOR_HELMET_CHAINMAIL, REPAIR_ARMOR)
+        new Achievement(NamespaceID.fromPool("minecraft", "get_chainmail"), "getChainmail", Items.ARMOR_HELMET_CHAINMAIL, REPAIR_ARMOR)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement OPEN_GUIDEBOOK =
-        new Achievement(NamespaceID.getPermanent("minecraft", "open_guidebook"), "openGuidebook", Blocks.BOOKSHELF_PLANKS_OAK, OPEN_INVENTORY)
+        new Achievement(NamespaceID.fromPool("minecraft", "open_guidebook"), "openGuidebook", Blocks.BOOKSHELF_PLANKS_OAK, OPEN_INVENTORY)
             .setClientsideAchievement()
             .registerAchievement();
     public static Achievement CAUGHT_EM_ALL =
-        new Achievement(NamespaceID.getPermanent("minecraft", "caught_em_all"), "caughtEmAll", Items.LANTERN_FIREFLY_GREEN, BUILD_WORKBENCH)
+        new Achievement(NamespaceID.fromPool("minecraft", "caught_em_all"), "caughtEmAll", Items.LANTERN_FIREFLY_GREEN, BUILD_WORKBENCH)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement ALL_MUSIC_DISCS =
-        new Achievement(NamespaceID.getPermanent("minecraft", "all_music_discs"), "allMusicDiscs", Items.RECORD_STAL, null)
+        new Achievement(NamespaceID.fromPool("minecraft", "all_music_discs"), "allMusicDiscs", Items.RECORD_STAL, null)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement TRIPLE_HIT =
-        new Achievement(NamespaceID.getPermanent("minecraft", "triple_hit"), "tripleHit", Items.AMMO_ARROW_GOLD, KILL_ENEMY)
+        new Achievement(NamespaceID.fromPool("minecraft", "triple_hit"), "tripleHit", Items.AMMO_ARROW_GOLD, KILL_ENEMY)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
 
 
     // Nether achievements
     public static Achievement ENTER_NETHER =
-        new Achievement(NamespaceID.getPermanent("minecraft", "enter_nether"), "enterNether", Blocks.OBSIDIAN, null)
+        new Achievement(NamespaceID.fromPool("minecraft", "enter_nether"), "enterNether", Blocks.OBSIDIAN, null)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement GET_NETHERCOAL =
-        new Achievement(NamespaceID.getPermanent("minecraft", "get_nethercoal"), "getNethercoal", Items.NETHERCOAL, ENTER_NETHER)
+        new Achievement(NamespaceID.fromPool("minecraft", "get_nethercoal"), "getNethercoal", Items.NETHERCOAL, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
     public static Achievement LIGHT_SIGN =
-        new Achievement(NamespaceID.getPermanent("minecraft", "light_sign"), "lightSign", Items.DUST_GLOWSTONE, ENTER_NETHER)
+        new Achievement(NamespaceID.fromPool("minecraft", "light_sign"), "lightSign", Items.DUST_GLOWSTONE, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
     public static Achievement SWIM_NETHER =
-        new Achievement(NamespaceID.getPermanent("minecraft", "swim_nether"), "swimNether", Blocks.ICE, ENTER_NETHER)
+        new Achievement(NamespaceID.fromPool("minecraft", "swim_nether"), "swimNether", Blocks.ICE, ENTER_NETHER)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement HIT_FIREBALL =
-        new Achievement(NamespaceID.getPermanent("minecraft", "hit_fireball"), "hitFireball", Items.AMMO_FIREBALL, ENTER_NETHER)
+        new Achievement(NamespaceID.fromPool("minecraft", "hit_fireball"), "hitFireball", Items.AMMO_FIREBALL, ENTER_NETHER)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement SLEEP_NETHER =
-        new Achievement(NamespaceID.getPermanent("minecraft", "sleep_nether"), "sleepNether", Items.BED, ENTER_NETHER)
+        new Achievement(NamespaceID.fromPool("minecraft", "sleep_nether"), "sleepNether", Items.BED, ENTER_NETHER)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
 //    public static Achievement ENTER_WARRENS =
@@ -142,11 +142,11 @@ public abstract class Achievements
 //            .setType(Achievement.TYPE_NORMAL)
 //            .registerAchievement();
     public static Achievement MOST_WANTED =
-        new Achievement(NamespaceID.getPermanent("minecraft", "most_wanted"), "mostWanted", Items.TOOL_SWORD_GOLD, ENTER_NETHER)
+        new Achievement(NamespaceID.fromPool("minecraft", "most_wanted"), "mostWanted", Items.TOOL_SWORD_GOLD, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
     public static Achievement FAST_TRAVEL = // TODO
-        new Achievement(NamespaceID.getPermanent("minecraft", "fast_travel"), "fastTravel", Blocks.GRASS, ENTER_NETHER)
+        new Achievement(NamespaceID.fromPool("minecraft", "fast_travel"), "fastTravel", Blocks.GRASS, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
 
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/Stat.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/Stat.java
index a7d3f0f31..b90489c0d 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/Stat.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/Stat.java
@@ -25,7 +25,7 @@ public class Stat
     public Stat(NamespaceID id, String key, StatValueFormatter statType)
     {
         clientside = false;
-        statId = id.makePermanent();
+        statId = id.copyUnpooled();
         statKey = key;
         this.statType = statType;
     }
